//+------------------------------------------------------------------+
//|                                                     e-Friday.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//| 08.10.2005                                          |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"


//-------    --------------------------------
extern string _Parameters_Trade = "-----  ";
extern int    MAGIC           = 20051008;
extern double Lots            = 0.1;    //   
extern int    lStopLoss       = 67;     //   
extern int    sStopLoss       = 47;     //   
extern int    TakeProfit      = 0;      //   
extern int    lHourOpenPos    = 1;      //   
extern int    sHourOpenPos    = 7;      //   
extern bool   UseClosePos     = True;   //   
extern int    lHourClosePos   = 23;     //   
extern int    sHourClosePos   = 19;     //   
extern bool   UseTrailing     = True;   //  
extern bool   ProfitTrailing  = True;   //   
extern int    TrailingStop    = 60;     //   
extern int    TrailingStep    = 5;      //  
extern int    Slippage        = 3;      //  

extern string _Parameters_Expert = "-----  ";
extern bool   UseOneAccount = False;        //     
extern int    NumberAccount = 11111;        //   
extern string Name_Expert   = "e-Friday.mq4";
extern bool   UseSound      = True;         //   
extern string NameFileSound = "expert.wav"; //   
extern color  clOpenBuy     = LightBlue;    //   
extern color  clOpenSell    = LightCoral;   //   
extern color  clModifyBuy   = Aqua;         //   
extern color  clModifySell  = Tomato;       //   
extern color  clCloseBuy    = Blue;         //   
extern color  clCloseSell   = Red;          //   

//----    -------------------------------
int prevDay;

//-------    --------------------------------

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void deinit() {
  Comment("");
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() {
  double Op1=iOpen (NULL, PERIOD_D1, 1);
  double Cl1=iClose(NULL, PERIOD_D1, 1);

  if (!IsTesting()) {
    if (UseOneAccount && AccountNumber()!=NumberAccount) {
      Comment("  : "+AccountNumber()+" !");
      return;
    } else Comment("");
  }

  if (DayOfWeek()==5) {
    if (Op1>Cl1 && Hour()==lHourOpenPos) OpenPosition(1);
    if (Op1<Cl1 && Hour()==sHourOpenPos) OpenPosition(0);
  }
  if (UseClosePos) {
    if (Op1>Cl1 && (Hour()>=lHourClosePos || prevDay!=Day())) CloseAllPositions();
    if (Op1<Cl1 && (Hour()>=sHourClosePos || prevDay!=Day())) CloseAllPositions();
  }
  if (UseTrailing) TrailingPositions();
  prevDay=Day();
}

//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OpenPosition(int op) {
  double ldStop=0, ldTake=0;

  if (!ExistPosition()) {
    if (op==1) {
      if (lStopLoss!=0) ldStop=Ask-lStopLoss*Point;
      if (TakeProfit!=0) ldTake=Ask+TakeProfit*Point;
      SetOrder(OP_BUY, Ask, ldStop, ldTake);
    }
    if (op==0) {
      if (sStopLoss!=0) ldStop=Bid+sStopLoss*Point;
      if (TakeProfit!=0) ldTake=Bid-TakeProfit*Point;
      SetOrder(OP_SELL, Bid, ldStop, ldTake);
    }
  }
}

//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
bool ExistPosition() {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          Exist=True; break;
        }
      }
    }
  }
  return(Exist);
}

//+------------------------------------------------------------------+
//|                                                   |
//| :                                                       |
//|   op     -                                               |
//|   pp     -                                                   |
//|   ldStop -                                            |
//|   ldTake -                                            |
//+------------------------------------------------------------------+
void SetOrder(int op, double pp, double ldStop, double ldTake) {
  color  clOpen;
  string lsComm=GetCommentForOrder();

  if (op==OP_BUYLIMIT || op==OP_BUYSTOP) clOpen=clOpenBuy;
  else clOpen=clOpenSell;
//  Lots=MathCeil(AccountFreeMargin()/10000*10)/10;
  OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpen);
  if (UseSound) PlaySound(NameFileSound);
}

//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
string GetCommentForOrder() {
  return(Name_Expert);
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void CloseAllPositions() {
  bool fc;
  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        fc=False;
        if (OrderType()==OP_BUY) {
          fc=OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy);
        }
        if (OrderType()==OP_SELL) {
          fc=OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell);
        }
        if (fc && UseSound) PlaySound(NameFileSound);
      }
    }
  }
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void TrailingPositions() {
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        if (OrderType()==OP_BUY) {
          if (!ProfitTrailing || (Bid-OrderOpenPrice())>TrailingStop*Point) {
            if (OrderStopLoss()<Bid-(TrailingStop+TrailingStep-1)*Point) {
              ModifyStopLoss(Bid-TrailingStop*Point, clModifyBuy);
            }
          }
        }
        if (OrderType()==OP_SELL) {
          if (!ProfitTrailing || OrderOpenPrice()-Ask>TrailingStop*Point) {
            if (OrderStopLoss()>Ask+(TrailingStop+TrailingStep-1)*Point || OrderStopLoss()==0) {
              ModifyStopLoss(Ask+TrailingStop*Point, clModifySell);
            }
          }
        }
      }
    }
  }
}

//+------------------------------------------------------------------+
//|   StopLoss                                          |
//| :                                                       |
//|   ldStopLoss -  StopLoss                                  |
//|   clModify   -                                    |
//+------------------------------------------------------------------+
void ModifyStopLoss(double ldStop, color clModify) {
  bool   fm;
  double ldOpen=OrderOpenPrice();
  double ldTake=OrderTakeProfit();

  fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, clModify);
  if (fm && UseSound) PlaySound(NameFileSound);
}
//+------------------------------------------------------------------+

